Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 863281 - sci-physics/geant-4.11.0.3 fails to compile (lto): G4Cons.cc:65:6: error: type ENorm violates the C++ One Definition Rule [-Werror=odr]
Summary: sci-physics/geant-4.11.0.3 fails to compile (lto): G4Cons.cc:65:6: error: typ...
Status: CONFIRMED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Guilherme Amadio
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: lto
  Show dependency tree
 
Reported: 2022-08-03 07:06 UTC by Agostino Sarubbo
Modified: 2022-11-03 23:28 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log.xz (build.log.xz,101.32 KB, application/x-xz)
2022-08-03 07:06 UTC, Agostino Sarubbo
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Agostino Sarubbo gentoo-dev 2022-08-03 07:06:32 UTC
https://blogs.gentoo.org/ago/2020/07/04/gentoo-tinderbox/

Issue: sci-physics/geant-4.11.0.2 fails to compile (lto).
Discovered on: amd64 (internal ref: lto_tinderbox)

NOTE:
This machine uses lto with CFLAGS=-flto -Werror=odr -Werror=lto-type-mismatch -Werror=strict-aliasing

Here is a bit of explanation:

-Werror=lto-type-mismatch:
User to find possible runtime issues in packages. It likely means the package is unsafe to build & use with LTO.
For projects using the same identifier but with different types across different files, they must be fixed to be consistent across the codebase.

-Werror=odr:
Used to find possible runtime issues in packages. These bugs are a problem anyway but may be even worse when combined with LTO. C++ code must comply with the One Definition Rule (ODR) - see https://en.cppreference.com/w/cpp/language/definition#One_Definition_Rule.

-Werror=strict-aliasing:
Used to find possible runtime issues in packages. These bugs are a problem anyway but may be even worse when combined with LTO.

Workarounds:
- If upstream is friendly and still active, file a bug upstream. For emulators, codecs, games, or multimedia packages, it may be worth just applying a workaround instead, as upstreams sometimes aren't receptive to these bugs (VALID FOR ALL).
- Use the new 'filter-lto' from flag-o-matic.eclass as it's likely to be unsafe with LTO (VALID FOR lto-type-mismatch - odr).
- Fix it yourself if interested, of course (VALID FOR ALL).
- Append-flags -fno-strict-aliasing (VALID FOR strict-aliasing).
- Use memcpy() but a union is sometimes suitable too (VALID FOR strict-aliasing).
- -fstrict-aliasing is implied by -O2, so this must be addressed in some form (VALID FOR strict-aliasing).

See also: https://marc.info/?l=gentoo-dev&m=165639574126280&w=2
Comment 1 Agostino Sarubbo gentoo-dev 2022-08-03 07:06:38 UTC
Created attachment 797152 [details]
build.log.xz

build log and emerge --info (compressed because it exceeds attachment limit, use 'xzless' to read it)
Comment 2 Agostino Sarubbo gentoo-dev 2022-08-03 07:06:41 UTC
Error(s) that match a know pattern in addition to what has been reported in the summary:


FAILED: BuildProducts/lib64/libG4geometry.so 
/var/tmp/portage/sci-physics/geant-4.11.0.2/work/geant4-v11.0.2/source/geometry/solids/CSG/src/G4Cons.cc:65:6: error: type ‘ENorm’ violates the C++ One Definition Rule [-Werror=odr]
Comment 3 Agostino Sarubbo gentoo-dev 2022-11-03 12:07:21 UTC
lto_tinderbox has reproduced this issue with version 4.11.0.3 - Updating summary.
Comment 4 Guilherme Amadio gentoo-dev 2022-11-03 16:15:58 UTC
This has been addressed upstream after I filed an issue, but the patch doesn't apply cleanly into 11.0.3, so this bug will be fixed when the next release is added to Gentoo (it usually comes in early December of each year).
Comment 5 Sam James archtester Gentoo Infrastructure gentoo-dev Security 2022-11-03 22:49:51 UTC
(In reply to Guilherme Amadio from comment #4)
> This has been addressed upstream after I filed an issue, but the patch
> doesn't apply cleanly into 11.0.3, so this bug will be fixed when the next
> release is added to Gentoo (it usually comes in early December of each year).

1. Thank you!
2. It's no big deal if not, but by chance do you have a link to the report?
Comment 6 Guilherme Amadio gentoo-dev 2022-11-03 23:16:53 UTC
Yes, the link is https://gitlab.cern.ch/geant4/geant4-dev/-/issues/145, but it's not public. It's behind CERN SSO, and you have to be in the Geant4 collaboration to see as well.
Comment 7 Sam James archtester Gentoo Infrastructure gentoo-dev Security 2022-11-03 23:28:52 UTC
(In reply to Guilherme Amadio from comment #6)
> Yes, the link is https://gitlab.cern.ch/geant4/geant4-dev/-/issues/145, but
> it's not public. It's behind CERN SSO, and you have to be in the Geant4
> collaboration to see as well.

Thanks, no worries, I'm just trying to collect some of these bugs for an overview of how progress is going wrt LTO. Much appreciated!